#ifndef __ABSTRACT_ASSEMBLER_H_

#define __ABSTRACT_ASSEMBLER_H_

#include "globals.h"
#include "IDBAOption.h"
#include "Read.h"
#include "Reader.h"
#include "Sequence.h"

#include <vector>

class IDBAOption;
class Contig;
class Read;

class AbstractAssembler
{
public:
    AbstractAssembler(const IDBAOption &option, int64 read_buffer = 0);
    virtual ~AbstractAssembler() {}

    std::vector<Sequence> &GetLongReads();
    //{ return long_reads; }

    std::vector<Read> &GetShortReads();
    void RewindShortReads()
    { read_reader->Rewind(); read_num = 0; }
    void ReleaseShortReads()
    { std::vector<Read>().swap(reads); RewindShortReads(); }

    virtual void Assemble(std::vector<Contig> &contigs) = 0;

protected:
    IDBAOption option;

private:
    void ReadBunchOfReads(std::vector<Read> &reads, int64 expected_num);

    std::vector<Sequence> long_reads;
    std::vector<Read> reads;
    std::vector<Read> empty_reads;
    int read_buffer;
    Reader *read_reader;
    int64 read_num;
};

#endif
