#ifndef __SIMPLE_TRAN_ASSMBLER_H_

#define __SIMPLE_TRAN_ASSMBLER_H_

#include "globals.h"
#include "HashGraph.h"
#include "AbstractAssembler.h"
#include "IDBAOption.h"

#include <vector>

class Contig;

class SimpleTranAssembler: public AbstractAssembler
{
public:
    SimpleTranAssembler(const IDBAOption &option, int64 read_buffer = 0)
        : AbstractAssembler(option, read_buffer) 
    { hash_graph = new HashGraph; }

    virtual ~SimpleTranAssembler() 
    { delete hash_graph; }

    virtual void Assemble(std::vector<Contig> &contigs);
    
private:
    void BuildKmerNodes();
    void AddInternalKmerNodes();

    HashGraph *hash_graph;
};

#endif
