#ifndef __UTILS_H_

#define __UTILS_H_

#include "globals.h"

#include <cstdio>
#include <vector>
#include <string>

struct Sequence;
struct HashGraph;
struct Contig;

enum OptionType { OptionBool, OptionInt, OptionDouble, OptionString };
enum ParameterType { SIMPLE, INTEGER, FLOAT, STRING, };

void AddOption(const std::string &long_name, const std::string &short_name,
        bool &bool_option, const std::string &description);
void AddOption(const std::string &long_name, const std::string &short_name,
        int &int_option, const std::string &description);
void AddOption(const std::string &long_name, const std::string &short_name,
        double &double_option, const std::string &description);
void AddOption(const std::string &long_name, const std::string &short_name,
        std::string &string_option, const std::string &description);

void ProcessOptions(int &argc, char *argv[]);
std::string OptionDescriptions();

bool IsExist(const std::string &filename);

void AddParameter(const char *name, void *pointer, ParameterType type);
void ProcessParameters(int &argc, char *argv[]);


FILE *OpenFile(const char *filename, const char *mode);

void ReplaceComma(std::string &s);
void SplitString(const std::string &s, std::vector<std::string> &items);

//bool ReadFastq(std::FILE *fp, Sequence *seq,
//               char *comment = NULL, char *quality = NULL);
//bool ReadFasta(std::FILE *fp, Sequence *seq, char *comment = NULL);
//void WriteFasta(std::FILE *fp, Sequence *seq, const char *comment = NULL);
//
//uint64 CountSequences(std::FILE *fp, bool isCheck = false);
//uint64 ReadHashGraph(std::FILE *fp,
//                   HashGraph *hashGraph, unsigned minCount = 0);
//uint64 WriteHashGraph(std::FILE *fp,
//                      HashGraph *hashGraph, unsigned minCount = 0);

//void ReadContigs(std::FILE *fp, std::vector<Contig> &contigs, bool code = false);
//void WriteContigs(std::FILE *fp, std::vector<Contig> &contigs, bool code = false, int minLength = 0);
//void CalculateN50(std::vector<Contig> &contigs, int64 &total, int64 &n50);
// uint64 ReadContigGraph(std::FILE *fp, ContigGraph *contigGraph);

#endif
