#include "globals.h"
#include "Contig.h"
#include "SimpleAssembler.h"
#include "Log.h"

#include <vector>
#include <sstream>
#include <cmath>

using namespace std;

void SimpleAssembler::Assemble(vector<Contig> &contigs)
{
    kmerLength = option.mink;

    BuildKmerNodes();
    
    //int x;
    //cin >> x;

    //AddInternalKmerNodes();

    //cin >> x;

    //ReleaseShortReads();

    //cin >> x;

    hash_graph->RefreshEdges();
    hash_graph->RemoveDeadEnd(100);
    hash_graph->RemoveLowCoverageContigs(sqrt(hash_graph->AverageCoverage()));
    hash_graph->Assemble(contigs);
}

void SimpleAssembler::BuildKmerNodes()
{
    //vector<vector<Kmer32> > solid_kmers(1 << option.prefix_length);

//    int64 totalKmer = 0;
//    int64 maximum = 0;

//    string kmer_files[1 << option.prefix_length];
//    for (int i = 0; i < (1 << option.prefix_length); ++i)
//    {
//        stringstream ss;
//        ss << option.prefix << ".kmer-" << i;
//        kmer_files[i] = ss.str();
//    }

//    for (int prefix = 0; prefix < (1 << option.prefix_length); ++prefix)
//    {
//        RewindShortReads();
//        while (true)
//        {
//            vector<Read> &reads = GetShortReads();
//            if (reads.size() == 0)
//                break;
//
//
//#pragma omp parallel for
//            for (int i = 0; i < (int64)reads.size(); ++i)
//            {
//                if (!reads[i].IsActive() || reads[i].Size() < kmerLength)
//                    continue;
//
//                Sequence seq;
//                seq = reads[i];
//                hash_graph->InsertSequence(seq, prefix, option.mask);
//            }
//        }
//
//        vector<Sequence> &long_reads = GetLongReads();
//#pragma omp parallel for
//        for (int i = 0; i < (int)long_reads.size(); ++i)
//            hash_graph->InsertSequence(long_reads[i], prefix, option.mask);

//        cout << "table size " << hash_graph->NumNodes() << " " << hash_graph->table_size << " " << hash_graph->backup.size()  << endl;
//        hash_graph->RefreshVertices(option.min_count);
//
//        //hash_graph->Save(solid_kmers[prefix]);
//        hash_graph->Save(kmer_files[prefix]);
//        //cout << "solid kmer " << solid_kmers[prefix].size() << endl;
//        cout << "solid kmer " << hash_graph->NumNodes() << endl;
//        hash_graph->Clear();
//
//        totalKmer = hash_graph->NumNodes();
//        if (hash_graph->NumNodes() > maximum)
//            maximum = hash_graph->NumNodes();
//    }


//    int x;
//    cin >> x;
    //vector<Read> &reads = GetShortReads();
//    for (unsigned i = 0; i < (1 << option.prefix_length); ++i)
//    {
//        //hash_graph->Load(solid_kmers[i]);
//        hash_graph->Load(kmer_files[i]);
//        cout << "table size " << hash_graph->NumNodes() << " " << hash_graph->table_size << " " << hash_graph->backup.size()  << endl;
//    }

    FILE *fkmer = fopen(option.kmer_file.c_str(), "rb");
    hash_graph->Load(fkmer);
    fclose(fkmer);


    //cout << "table size " << hash_graph->NumNodes() << " " << hash_graph->table_size << " " << hash_graph->backup.size()  << endl;
    LogMessage("total kmer %lld\n", hash_graph->NumNodes());
}

void SimpleAssembler::AddInternalKmerNodes()
{
    RewindShortReads();
    while (true)
    {
        vector<Read> &reads = GetShortReads();
        if (reads.size() == 0)
            break;

#pragma omp parallel for
        for (int i = 0; i < (int64)reads.size(); ++i)
        {
            if (!reads[i].IsActive() || reads[i].Size() < kmerLength)
                continue;

            Sequence seq;
            seq = reads[i];
            seq.Trim(option.trim);
            hash_graph->AddEdgesAndInternalKmers(seq);
        }
    }

    LogMessage("after addback total kmer %lld\n", hash_graph->NumNodes());
}
