#include "globals.h"
#include "BlatRecord.h"

#include <iostream>
#include <cstdio>
#include <cmath>

using namespace std;

char buf[MaxLine];
char line[MaxLine];
vector<vector<BlatRecord> > scaffolds;

bool Check(vector<BlatRecord> &records)
{
    bool flag = true;
    for (unsigned i = 0; i+1 < records.size(); ++i)
    {
        if (fabs(records[i].ref_to - records[i+1].ref_from) > 200)
            flag = false;
    }

    if (flag)
        return true;

    flag = true;
    for (unsigned i = 0; i+1 < records.size(); ++i)
    {
        if (fabs(records[i+1].ref_to - records[i].ref_from) > 250)
            flag = false;
    }

    return flag;
}

int main()
{
    vector<BlatRecord> records;
    string name;
    string previous;
    while (fgets(line, MaxLine, stdin) != NULL)
    {
        BlatRecord record;
        record.Parse(line);

        if (record.ref_to - record.ref_from < record.match_count * 1.2
                && record.match_count > record.query_length * 0.8)
        {
            //cout << name << endl;
            name = record.query_name;
            while (name[name.size()-1] != '_')
                name.resize(name.size()-1);
            name.resize(name.size()-1);

          if (name == previous)
                records.push_back(record);
            else
            {
                scaffolds.push_back(records);
                previous = name;
                records.resize(0);
                records.push_back(record);
            }

            cout << record.query_name << " " << record.ref_from << " " << record.ref_to << " " << record.match_count  << endl;
        }
    }

    int sum = 0;
    for (unsigned i = 0; i < scaffolds.size(); ++i)
    {
        cout << Check(scaffolds[i]) << endl;
        if (!Check(scaffolds[i]))
        {
            for (unsigned j = 0; j < scaffolds[i].size(); ++j)
            {
                BlatRecord record = scaffolds[i][j];
                cout << record.query_name << " " << record.ref_from << " " << record.ref_to << " " << record.match_count  << endl;
                sum += record.query_length;
            }
        }
    }
    cout << sum << endl;


    return 0;
}
