#include "globals.h"
#include "Sequence.h"
#include "Reader.h"
#include "Utils.h"
#include "Writer.h"

#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

int min_contig = 100;

int main(int argc, char *argv[])
{
    AddParameter("minContig", &min_contig, INTEGER);
    ProcessParameters(argc, argv);

    if (argc < 3)
    {
        fprintf(stderr, "filterContigs in-file out-file\n");
        exit(1);
    }

    FastAReader reader(argv[1]);
    FastAWriter writer(argv[2]);

    Sequence seq;
    string comment;

    int index = 0;
    while (reader.Read(seq, comment))
    {
        if (seq.Size() < min_contig)
            continue;
        else
        {
            writer.WriteFormat(seq, "contig%d", index++);
            //writer.Write(seq, comment);
        }
    }

    return 0;
}

