#include "globals.h"
#include "Sequence.h"
#include "Reader.h"
#include "Utils.h"
#include "Writer.h"

#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

int min_contig = 100;

int main(int argc, char *argv[])
{
    AddParameter("minContig", &min_contig, INTEGER);
    ProcessParameters(argc, argv);

    if (argc < 4)
    {
        fprintf(stderr, "filterContigs in-file out-file\n");
        exit(1);
    }

    int64 num_reads = atoll(argv[3]);
    if (num_reads%2)
        num_reads -= 1;

    FastAReader reader(argv[1]);
    FastAWriter writer(argv[2]);

    int64 total_reads = reader.NumReads() / 2;
    vector<int> aux(total_reads);
    for (int i = 0; i < total_reads; ++i)
        aux[i] = i;
    for (int i = total_reads-1; i > 0; --i)
        swap(aux[i], aux[rand()%i]);

    vector<int> indices(num_reads);
    for (int i = 0; i < num_reads/2; ++i)
    {
        indices[2*i] = 2*aux[i];
        indices[2*i+1] = 2*aux[i] + 1;
    }
    sort(indices.begin(), indices.end());

    Sequence seq;
    string comment;

    int index = 0;
    int k = 0;
    while (reader.Read(seq, comment))
    {
        if (index == indices[k])
        {
            writer.Write(seq, comment);
            ++k;

            if (k == num_reads)
                break;
        }

        ++index;

//        if (index == num_reads)
//            break;
    }

    return 0;
}

