#include <cstdio>
#include <algorithm>
#include <cstring>
#include <iostream>
#include <cmath>
#include <ctime>
#include <vector>
#include <map>
using namespace std;
int vect1[256],vect2[256];
unsigned int s;
int nuclcode(char para)
{
    int result;
    switch (para)
    {
    case 'A':result = 0;
            break;
    case 'C':result = 1;
            break;
    case 'G':result = 2;
            break;
    case 'T':result = 3;
            break;
    default :result = -1;
            cout<<"unrecognizable nucleotide . code in nuclcode(char para)"<<endl;
            exit(1);
    }
    return result;
}
int position(int para)
{
    int comp = 255 - para;
    int revercomple = comp % 4;
    for(int i=1;i<4;i++)
    {
        comp /= 4;
        revercomple *=4;
        revercomple += (comp%4);
    }
    return revercomple<para?revercomple:para;
}
int revercomple(int para)
{
    int comp = 255 - para;
    int result = comp % 4;
    for(int i=1;i<4;i++)
    {
        comp /= 4;
        result *=4;
        result += (comp%4);
    }
    return result;
}
int rand4()
{
    s=s*s+s/13+rand();
    return s%4;
}
int genedistance()
{
    int distance=0;
    for(int i=0;i<256;i++)
        vect1[i]=vect2[i]=0;
    int fourmer1 = rand()%256;

    vect1[fourmer1]++;
    for(int i=0;i<996;i++)
    {
        fourmer1 *= 4;
        fourmer1 += rand4();
        fourmer1 %= 256;
        vect1[fourmer1]++;
    }
    
    int fourmer2 = rand()%256;
    vect2[fourmer2]++;
    for(int i=0;i<999;i++)
    {
        fourmer2 *= 4;
        fourmer2 += rand4();
        fourmer2 %= 256;
        vect2[fourmer2]++;
    }
    for(int i=0;i<256;i++)
    {
        int rever = revercomple(i);
        if(rever>i)
        {
            vect1[i]+=vect1[rever];
            vect1[rever]=-1;
            vect2[i]+=vect2[rever];
            vect2[rever]=-1;
        }
    }
    for(int i=0;i<256;i++)
    {
        distance += abs(vect2[i]-vect1[i]);
    }
    return distance;
}
int main()
{
    int distribution[2001];
    for(int i=0;i<2001;i++)
        distribution[i]=0;
    srand((unsigned)time(NULL));    
    for(int i=0;i<2000000;i++)
        distribution[genedistance()]++;
    for(int i=0;i<2001;i++)
    {
        if(distribution[i]==0)continue;
        cout<<i<<"\t"<<distribution[i]<<endl;
    }
    FILE* fp=fopen("/home/ywang/test/distribution.txt","at");
    for(int i=0;i<2001;i++)
    {
        if(distribution[i]==0)continue;
            fprintf(fp,"%d,%d\n",i,distribution[i]);
    }
    return 0;
}
