#include "globals.h"
#include "Sequence.h"
#include "Reader.h"
#include "Utils.h"
#include "Writer.h"

#include <iostream>
#include <algorithm>
#include <cstdio>

using namespace std;

int min_contig = 100;

int main(int argc, char *argv[])
{
    AddParameter("minContig", &min_contig, INTEGER);
    ProcessParameters(argc, argv);

    if (argc < 3)
    {
        fprintf(stderr, "filterContigs in-file out-file\n");
        exit(1);
    }

    FastAReader reader(argv[1]);
    FastAWriter writer(argv[2]);

    //int index = 0;
    Sequence seq;
    string comment;
    while (reader.Read(seq, comment))
    {
        string s = seq.ToCString();
        for (unsigned i = 0; i < s.size(); ++i)
            if (s[i] == 'N')
                s[i] = ' ';
        vector<string> items;
        SplitString(s, items);

//        if (items.size() == 1)
//            continue;
//
        int index = 0;
        for (unsigned i = 0; i < items.size(); ++i)
        {
            Sequence t = items[i];
            writer.WriteFormat(t, "%s_%d", comment.c_str(), index++);
        }
    }

    return 0;
}

