#include "globals.h"
#include "Sequence.h"
#include "Log.h"
#include "Reader.h"
#include "Writer.h"
#include "Utils.h"

#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cstring>
#include <set>
#include <string>
#include <map>

using namespace std;

char buf[MaxLine];
char line[MaxLine];

int ref_size[MaxLine] = {0};
int alined_size[MaxLine] = {0};
int alined_size2[MaxLine] = {0};
vector<int> matchs[MaxLine];
vector<int> matchs2[MaxLine];
int cover_count2[MaxLine] = {0};
int cover_count_common[MaxLine] = {0};
int cover_bases_count2[MaxLine] = {0};
int cover_bases_common[MaxLine] = {0};

int main(int argc, char *argv[])
{
    FILE *fp1 = fopen(argv[1], "rb");
    FILE *fp2 = fopen(argv[2], "rb");

    fgets(line, MaxLine, fp1);
    fgets(line, MaxLine, fp1);
    fgets(line, MaxLine, fp1);

    fgets(line, MaxLine, fp2);
    fgets(line, MaxLine, fp2);
    fgets(line, MaxLine, fp2);

    int n = 0;
    while (fgets(line, MaxLine, fp1) != NULL)
    {
        int id, aligned, ref;
        sscanf(line, "%d, %d, %d", &id, &aligned, &ref);
        //cout << id << " " << aligned << " " << ref << endl;
        ref_size[id] = ref;
        alined_size[id] = aligned;

        if (id > n)
            n = id;

        matchs[id].resize(ref);
        for (int i = 0; i < ref; ++i)
        {
            fscanf(fp1, "%d", &matchs[id][i]);
        }
        fgets(line, MaxLine, fp1);
    }

    while (fgets(line, MaxLine, fp2) != NULL)
    {
        int id, aligned, ref;
        sscanf(line, "%d, %d, %d", &id, &aligned, &ref);
        ref_size[id] = ref;
        alined_size2[id] = aligned;

        if (id > n)
            n = id;

        matchs2[id].resize(ref);
        for (int i = 0; i < ref; ++i)
        {
            fscanf(fp2, "%d", &matchs2[id][i]);
        }
        fgets(line, MaxLine, fp2);
    }

    ++n;
    int count1 = 0;
    int count2 = 0;
    int count_common = 0;

    int64 sum_matches_common = 0;
    int64 sum_matches_only1 = 0;
    int64 sum_matches_only2 = 0;

    //int64 sum_length1 = 0;
    int64 sum_length2 = 0;
    int64 sum_length_common = 0;

    int num_bases1 = 0;
    int num_bases2 = 0;
    int num_bases_common = 0;
    for (int i = 0; i < n; ++i)
    {
        if (alined_size[i] > 0.5 * ref_size[i])
        {
            for (unsigned j = 0; j < matchs[i].size(); ++j)
            {
                if (matchs[i][j] > 0)
                    ++num_bases1;
                sum_matches_only1 += matchs[i][j];
            }
            ++count1;
        }

        if (alined_size2[i] > 0.5 * ref_size[i])
        {
            int sum = 0;
            for (unsigned j = 0; j < matchs2[i].size(); ++j)
            {
                if (matchs2[i][j] > 0)
                    ++num_bases2;
                sum_matches_only2 += matchs2[i][j];
                sum += matchs2[i][j];
                ++cover_bases_count2[matchs2[i][j]];
            }
            ++count2;

            ++cover_count2[(sum + matchs2[i].size()/2)/matchs2[i].size()];
            sum_length2 += matchs2[i].size();
        }

        if (alined_size[i] > 0.5 * ref_size[i]
                && alined_size2[i] > 0.5 * ref_size[i])
        {
            int sum = 0;
            for (unsigned j = 0; j < matchs[i].size(); ++j)
            {
                if (matchs[i][j] > 0 && matchs2[i][j])
                    ++num_bases_common;
                sum_matches_common += matchs2[i][j];
                sum += matchs2[i][j];
                ++cover_bases_common[matchs2[i][j]];
            }
            ++count_common;

            ++cover_count_common[(sum + matchs2[i].size()/2) / matchs2[i].size()];
            sum_length_common += matchs2[i].size();
        }
    }

    printf("%d, %d, %d\n", count1, count2, count_common);
    printf("%d, %d, %d\n", num_bases1, num_bases2, num_bases_common);
    printf("%.3f, %.3f, %.3f\n", 1.0 * sum_matches_only2 / sum_length2,
            1.0 * (sum_matches_only2 - sum_matches_common) / (sum_length2 - sum_length_common), 
            1.0 * sum_matches_common / sum_length_common);

    for (int i = 0; i < 200; ++i)
        printf("%d, %d\n", i, cover_count2[i] - cover_count_common[i]);
    printf("\n");

    for (int i = 0; i < 200; ++i)
        printf("%d, %d\n", i, cover_count_common[i]);
    printf("\n");

    for (int i = 0; i < 200; ++i)
        printf("%d, %d\n", i, cover_bases_count2[i] - cover_bases_common[i]);
    printf("\n");

    for (int i = 0; i < 200; ++i)
        printf("%d, %d\n", i, cover_bases_common[i]);
    printf("\n");

    return 0;
}

